/*
//>>>>>  T I M E R - 0  D E F I N E S <<<<<
*/
//
#ifdef timer0_10us // -tested
const unsigned short timer0_10us_T0CON = 0xC8;
const unsigned short timer0_10us_TMR0L = 0xC2;
#endif

#ifdef timer0_25us // -tested
const unsigned short timer0_25us_T0CON = 0xC8;
const unsigned short timer0_25us_TMR0L = 0x4C;
#endif

#ifdef timer0_50us // -tested
const unsigned short timer0_50us_T0CON = 0xC0;
const unsigned short timer0_50us_TMR0L = 0x42;
#endif

#ifdef timer0_100us // -tested
const unsigned short timer0_100us_T0C0N = 0xC1;
const unsigned short timer0_100us_TMR0L = 0x3D;
#endif

#ifdef timer0_1ms   // -tested
const unsigned short timer0_1ms_T0CON   = 0xC4;
const unsigned short timer0_1ms_TMR0L   = 0x06;
#endif

#ifdef timer0_10ms  // -tested
const unsigned short timer0_10ms_T0CON = 0x80;
const unsigned short timer0_10ms_TMR0H = 0x63;
const unsigned short timer0_10ms_TMR0L = 0xC0;
#endif

#ifdef timer0_25ms  // -tested
const unsigned short timer0_25ms_T0CON = 0x81;
const unsigned short timer0_25ms_TMR0H = 0x3C;
const unsigned short timer0_25ms_TMR0L = 0xB0;
#endif

#ifdef timer0_100ms  // -tested
const unsigned short timer0_100ms_T0CON = 0x83;
const unsigned short timer0_100ms_TMR0H = 0x3C;
const unsigned short timer0_100ms_TMR0L = 0xB0;
#endif

#ifdef timer0_500ms  // - tested
const unsigned short timer0_500ms_T0CON = 0x85;
const unsigned short timer0_500ms_TMR0H = 0x0B;
const unsigned short timer0_500ms_TMR0L = 0xDC;
#endif

#ifdef timer0_1s // - tested
const unsigned short timer0_1s_T0CON = 0x86;
const unsigned short timer0_1s_TMR0H = 0x0B;
const unsigned short timer0_1s_TMR0L = 0xDC;
#endif

#ifdef timer0_10us
void InitTimer0()
{
  T0CON      = timer0_10us_T0CON;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0L      = timer0_10us_TMR0L;
  TMR0IE_bit = 1;
}
#endif

#ifdef timer0_25us
void InitTimer0()
{
  T0CON      = timer0_25us_T0CON;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0L      = timer0_25us_TMR0L;
  TMR0IE_bit = 1;
}
#endif

#ifdef timer0_50us
void InitTimer0()
{
  T0CON      = timer0_50us_T0CON;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0L      = timer0_50us_TMR0L;
  TMR0IE_bit = 1;
}
#endif

#ifdef timer0_100us
void InitTimer0()
{
  T0CON      = timer0_100us_T0C0N;
  //TMR0H      = timer0_100us_TMR0H;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0L      = timer0_100us_TMR0L;
  GIE_bit    = 1;
  TMR0IE_bit = 1;
}
#endif

#ifdef timer0_1ms
void InitTimer0()
{
  T0CON      = timer0_1ms_T0CON;

  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0L      = timer0_1ms_TMR0L;
  TMR0IE_bit = 1;
}
#endif

#ifdef timer0_10ms
void InitTimer0()
{
  T0CON      = timer0_10ms_T0CON;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0H      = timer0_10ms_TMR0H;
  TMR0L      = timer0_10ms_TMR0L;
  TMR0IE_bit = 1;
}
#endif

#ifdef timer0_25ms
void InitTimer0()
{
  T0CON      = timer0_25ms_T0CON;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0H      = timer0_25ms_TMR0H;
  TMR0L      = timer0_25ms_TMR0L;
  TMR0IE_bit = 1;
}
#endif


#ifdef timer0_100ms
void InitTimer0()
{
  T0CON      = timer0_100ms_T0CON;
  #ifdef timer0_lo_priority
    GIEL_Bit    = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0H      = timer0_100ms_TMR0H;
  TMR0L      = timer0_100ms_TMR0L;
  TMR0IE_bit = 1;

}
#endif

#ifdef timer0_500ms
void InitTimer0()
{
  T0CON      = timer0_500ms_T0CON;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0H      = timer0_500ms_TMR0H;
  TMR0L      = timer0_500ms_TMR0L;
  TMR0IE_bit = 1;
}
#endif

#ifdef timer0_1s
void InitTimer0()
{
  T0CON      = timer0_1s_T0CON;
  #ifdef timer0_lo_priority
    GIEL_bit = 1;        //globally enable low priority interrupts
    IPEN_bit    = 1;        //enable interrupt priority bit
    TMR0IP_bit  = 0;        // clear bit to enable low priorty
  #else //timer0_hi_priority
    TMR0IP_bit  = 1;        // set bit to enable hi priorty
  #endif
  TMR0H      = timer0_1s_TMR0H;
  TMR0L      = timer0_1s_TMR0L;
  TMR0IE_bit = 1;
}
#endif