//
//
// ensure that all associated files reside in the same directory
// as "TimerInterrupts.c". Alternatively you can modify to suit
// yourself. Look at "TimerInterrupts.c"
//
// Dependency:
//
// TimerInterrupts.c
//       |
//       |----> timer-0-def-08Mhz.c ... timer-6-def-08Mhz.c - if selected
//       |----> timer-0-def-32Mhz.c ... timer-6-def-32Mhz.c - if selected
//       |
//       |----> Interrupts_Lo.c
//        ----> Interrupts_Hi.c
//
// select path of timer support files
#include "D:\Dev\MikroE\00-TimerInterrupts\mcPro\timerLIB_Test\TimerInt_LIB\TimerInterrupts.c"

//#define _debug  // <== used to debug and measure interrupt times

int t0count,t1count,t2count,t3count,t4Count,t5count,t6count;


unsigned char timer0_isr  (void)
{
#ifndef _debug
   t0count++;
   if (t0count >= 20)
   {
      t0Count = 0;
      LATD.F0 = ~LATD.F0;
   }
#else
     LATD.F0 = 1;
     delay_us(5);
     LATD.F0 = 0;
#endif
}

unsigned char timer1_isr  (void)
{
#ifndef _debug
   t1Count++;
   if (t1count >= 21)
   {
      t1Count = 0;
      LATD.F1 = ~LATD.F1;
   }
#else
    LATD.F1 = 1;
    delay_us(5);
    LATD.F1 = 0;
#endif
}

unsigned char timer2_isr  (void)
{
#ifndef _debug
   t2Count++;
   if (t2count >= 200)
   {
      t2Count = 0;
      LATD.F2 = ~LATD.F2;
   }
#else
    LATD.F2 = 1;
    delay_us(5);
    LATD.F2 = 0;
#endif
}

unsigned char timer3_isr  (void)
{
#ifndef _debug
   t3Count++;
   if (t3count >= 9)
   {
      t3Count = 0;
      LATD.F3 = ~LATD.F3;
   }
#else
    LATD.F3 = 1;
    delay_us(5);
    LATD.F3 = 0;
#endif
}

unsigned char timer4_isr  (void)
{
#ifndef _debug
   t4Count++;
   if (t4count >= 5000)
   {
      t4Count = 0;
      LATD.F4 = ~LATD.F4;
   }
#else
    LATD.F4 = 1;
    delay_us(5);
    LATD.F4 = 0;
#endif
}

unsigned char timer5_isr  (void)
{
#ifndef _debug
   t5Count++;
   if (t5count >= 8)
   {
      t5Count = 0;
      LATD.F5 = ~LATD.F5;
   }
#else
    LATD.F5 = 1;
    delay_us(5);
    LATD.F5 = 0;
#endif
}

unsigned char timer6_isr  (void)
{
#ifndef _debug
   t6Count++;
   if (t6count >= 25)
   {
      t6Count = 0;
      LATD.F6 = ~LATD.F6;
   }
#else
    LATD.F6 = 1;
    delay_us(5);
    LATD.F6 = 0;
#endif
}




int k;

void main()
{

 PORTD       = 0;       //set PORTD as output
 TRISD       = 0;
 PORTC       = 0;       //set PORTD as output
 TRISC       = 0;

 t6Count     = 0;
 t5Count     = 0;
 t4Count     = 0;
 t3count     = 0;
 t2count     = 0;
 t1count     = 0;


  pt2_timer0_isr = &timer0_isr;
  InitTimer0();

  pt2_timer1_isr = &timer1_isr;
  InitTimer1();

  pt2_timer2_isr = &timer2_isr;
  InitTimer2();

  pt2_timer3_isr = &timer3_isr;
  InitTimer3();

  pt2_timer4_isr = &timer4_isr;
  InitTimer4();

  pt2_timer5_isr = &timer5_isr;
  InitTimer5();

  pt2_timer6_isr = &timer6_isr;
  InitTimer6();


 GIE_bit     = 1;
 GIEL_bit    = 1;


 k = 0;
while(1)
{
  k++;
  delay_ms(17);
  if (k > 10)
  {
    k = 0;
    LATD.F7 = ~LATD.F7;
  }
}

}//END==> main()